import win32.windows;
import win32.commctrl;
import std.string;
import std.utf;
import win32frame.writek;
import win32frame.CommonControl;

class StatusBar {
  private HWND hwnd ;
  private int  style ;

  this(){
    CommonControl cc = new CommonControl() ;
    style = WS_CHILD | WS_VISIBLE ;
    hwnd=null ;
  }
  
  int addStyle(int addstyle){
    this.style |= addstyle ;
    return(0) ;
  }
  
  int create(HWND phwnd, string str){
    if( this.hwnd==null ){
      this.hwnd = CreateStatusWindow( style, toUTFz!(wchar*)(str) , phwnd , 1 );
      if( this.hwnd==null ){
	return(-1) ;
      }
    }
    return(0) ;
  }

  void setText(string str){
    if( this.hwnd!=null ){
      SendMessage( this.hwnd, SB_SETTEXT, 0, cast(LPARAM)(toUTFz!(wchar*)(str)));
    }
  }

  HWND getHWND(){
    return( this.hwnd ) ;
  }

}
