import win32.windows;
import win32.commctrl;
import win32frame.writek;
import win32frame.CommonControlEx;

class ToolBarEx {
  HWND hwnd ;
  int  created ;
  int  style ;
  int  iconcntl=IDB_STD_SMALL_COLOR ;

  this(){
    CommonControlEx ccex = new CommonControlEx() ;
    style = WS_CHILD | WS_VISIBLE ;
    hwnd=null ;
  }

  int addStyle(int addstyle){
    this.style |= addstyle ;
    return(0) ;
  }
  
  int create(HWND phwnd, int id, int img_num, TBBUTTON tbb[], int bt_num){
    if( this.hwnd==null ){
      this.hwnd = CreateToolbarEx( phwnd, style ,
				   id, img_num,
				   HINST_COMMCTRL,
				   iconcntl ,
				   cast(TBBUTTON*)(tbb) , bt_num , 0 , 0 , 0 , 0 , TBBUTTON.sizeof
				   ) ;
      if( this.hwnd==null ){
	return(-1) ;
      }
    }
    return(0) ;
  }

  int addButton( TBBUTTON tbb[], TBADDBITMAP tb, int bt_num ){
    if( this.hwnd!=null ){
      SendMessage( this.hwnd, TB_ADDBITMAP  , cast(WPARAM)(bt_num) , cast(LPARAM)(&tb) );
      SendMessage( this.hwnd, TB_ADDBUTTONS , cast(WPARAM)(bt_num) , cast(LPARAM)(&tbb[0]) );
      SendMessage( this.hwnd, TB_AUTOSIZE, 0, 0) ;
    }
    return(0) ;
  }

  void resize(UINT msg , WPARAM wp , LPARAM lp){
    if( this.hwnd!=null ){
      SendMessage( this.hwnd, msg, wp , lp);
    }
  }

  int setICONcontrol(int IDB){
    int old=iconcntl ;
    iconcntl=IDB ;
    return(old) ;
  }
}
